#ifndef __CAAlign_H_
#define __CAAlign_H_

#include "alignapp.h"
#include "smallapp.h"

class crispraln:public alignapp
{
private:
	int	num_src;
	char	**src_seq;
	char	**src_name;
	int	*src_len;
	int	num_crispr;
	int	crispr_num;
	char	**crispr_name;
	char	**crispr_con;
	char	**crispr_seq;
	int	*crispr_len;
	int	**spacer_idx;
	int	**spacer_len;
	int	*spacer_len_sum;
	int	*spacer_num;
	char	**repeat_seq;
	int	*repeat_len;
	int	*crispr_truesupport;
	int	*crispr_falsesupport;
	int	speedup;
	int	spacerDiff;
	int	minSpacerLen;
	int	maxSpacerLen;
	int	minRepeatCopy;
	int	verbose;
	int	cA[1000], cT[1000], cG[1000], cC[1000];

public:
	crispraln(void) { ini_crispraln(); }
	~crispraln(void) { cleanupseq(); cleanupcrispr(); }
	void	ini_crispraln(void);
	void	cleanupseq(void);
	void	cleanupcrispr(void);
	int	readseq(char **seq, int *len_seq, char **src_name, FILE *fp);
	void	readcrispr(char *crisprfile);
	void	readrepeat(char *repeatfile);
	int	spacersim(int r, int s, int *repeatpos, int repeatcopy);
	int	left_partial_repeat(int repeatlen, char *repeatseq, int firstcopypos, int srclen, char *srcseq);
	int	right_partial_repeat(int repeatlen, char *repeatseq, int lastcopypos, int srclen, char *srcseq);
	void	consensus_new(int len);
	void	consensus_add(int len, char *seq);
	void	consensus_get(int len, char *con);
	int	get_mismatch(int repeatlen, char *repeat_int, char *repeat_char);
	int	crisprann(int allowmis, double iden, int partial, bool allowredun, FILE *out);
	int	crispralign(int allowmis, double iden, int partial);
	int	findrepeat(int repeatlen, char *repeatseq, int seqlen, char *seqseq, int allowmis, int removesmall, int *pos, int *repeatidx, int *repeatcopy);
	void	getseqs(char *seqfile);
	void	saveresults(char *outfile0);
	void	displayseq(char *src_seq, int len);
	void	int2seq(char *src_seq, int srclen, int start, int len, char *seq);
	char*   int2seq(char *src_seq, int len_seq);
	char*   seq2int(char *src_seq, int len_seq);
	void    writeseq(char *src_seq, char *src_name, int len_seq, FILE *fp);
	void	printaln(char *seq1, int len1, char *seq2, int len2, vector<int> aln);
	void	printnovel(char *file0);
	void	printsupported(char *file0);
	void	setverbose(void) { verbose = 1; }
	int 	comparcrispr(const void * p1, const void * p2);
};

#endif
